NB. plot defaults
NB.
NB. Note: names for global nouns defined in this script must be
NB. uppercase only. Plot does not use uppercase names in the
NB. code, therefore names defined here cannot conflict with it.

NB. =========================================================
NB. system specific definitions:
3 : 0''
if. IFWIN32 do.
  CAPTIONFONT=: 'Arial 18'
  KEYFONT=: 'Arial 15'
  LABELFONT=: 'Arial 15'
  SYMBOLFONT=: 'Symbol 15'
  TEXTFONT=: 'Arial 18'
  SUBTITLEFONT=: 'Arial 20'
  TITLEFONT=: 'Arial 24'
else.
  CAPTIONFONT=: 'sansserif 18'
  KEYFONT=: 'sansserif 15'
  LABELFONT=: 'sansserif 15'
  SYMBOLFONT=: 'monospaced 15'
  TEXTFONT=: 'sansserif 18'
  SUBTITLEFONT=: 'sansserif 18'
  TITLEFONT=: 'sansserif 20'
end.

if. IFCONSOLE do.
  OUTPUT=: 'pdf'
else.
  OUTPUT=: 'isi'
end.
)

NB. =========================================================
ASPECT=: 0
AXES=: 0
AXISCOLOR=: BLACK
BACKCOLOR=: WHITE
BANDCOLOR=: RGCLR
BORDER=: 0
BORDERSIZE=: 8
BOXED=: 1
CAPTIONCOLOR=: BLACK
CLEAR=: 1
CONTOURLEVELS=: 20
EDGECOLOR=: BLACK
EDGESIZE=: 1 NB. polygons etc
FORECOLOR=: BLACK
FONTSCALE=: 0.75 NB. 72%96
FRAME=: 1
FRAMEBACKCOLOR=: '' NB. color of frame background (if different from BACKCOLOR)
FRAMESTYLE=: '' NB. 'in|out', default choose from graph type
GRAPHBACKCOLOR=: '' NB. color of graph background (if different from BACKCOLOR)
GRIDCOLOR=: SILVER
GRIDPATTERN=: 1 0 0 NB. series of 1's followed by 0's
GRIDS=: 1
GUIDESIZE=: 1 NB. axes, grids, frame
ITEMCOLOR=: STDCLR
KEY=: ''
KEYCOLOR=: '' NB. color of keys, default itemcolor. Text uses labelcolor.
KEYPOS=: ''    NB. left|right top|bottom inside|outside (lti)
KEYSTYLE=: ''  NB. left|right boxed horizontal|vertical (lbv)
KEYTITLE=: ''
LABELCOLOR=: BLACK
LABELS=: 1
MARKERS=: '' NB. numeric indices into MarkerNames
MARKERSIZE=: 1 NB. marker size
MESH=: 1
ORIENTATION=: 2
PENPATTERN=: 1 0;12 6;2 4;12 6 2 4;12 6 2 4 2 4
PENSIZE=: 1 NB. line drawing except for guides and edges
PENSTYLE=: 0
PLOTCAPTION=: 'Plot'
POLAR=: 0
PSHOW=: '' NB. default style for pshow
RTIC=: ''
RULECOLOR=: BLACK
RULESIZE=: 1
SEPARATOR=: '|'
SHOWBOXES=: 0 NB. if show boxes (for debugging)
SUBTITLE=: '' NB. not used yet
SUBTITLECOLOR=: BLACK
SUBTITLESTYLE=: ''
SYMBOLCOLOR=: BLACK
SYMBOLS=: 197 196 35 43 42 167 168 169 170 { a.
TEXTCOLOR=: BLACK
TICMAJOR=: 7
TICMINOR=: 4
TICS=: 1
TICSTYLE=: '' NB. in|out default in
TITLE=: ''
TITLECOLOR=: BLACK
TITLESTYLE=: ''
TYPE=: ''
VIEWCENTER=: 0 0 0
VIEWPOINT=: 1.3 _2.4 2
VIEWPOINT=: 1.6 _2.4 1.5
VIEWSIZE=: 1 1 0.5
VIEWUP=: 0 0 1
VISIBLE=: 1
XCAPTION=: ''
XCAPTIONSTYLE=: ''
XGRIDPATTERN=: 3 5
XINT=: ''
XLABEL=: ''
XLABELSTYLE=: ''
XLOG=: 0
XRANGE=: ''
XGROUP=: ''
XTIC=: ''
XTICPOS=: ''
Y2AXIS=: '0'
YCAPTION=: ''
YCAPTIONSTYLE=: ''
YGRIDPATTERN=: 3 5
YINT=: ''
YLABEL=: ''
YLABELSTYLE=: ''
YLOG=: 0
YRANGE=: ''
YGROUP=: ''
YTIC=: ''
YTICPOS=: ''
Y2CAPTION=: ''
Y2CAPTIONSTYLE=: ''
Y2LABEL=: ''
Y2LABELSTYLE=: ''
Y2LOG=: 0
Y2RANGE=: ''
Y2TIC=: ''
Y2TICPOS=: ''
ZCAPTIONSTYLE=: ''
ZGRIDPATTERN=: 3 5
ZINT=: ''
ZLABEL=: ''
ZLABELSTYLE=: ''
ZLOG=: 0
ZRANGE=: ''
ZGROUP=: ''
ZTIC=: ''
ZTICPOS=: ''
