NB. border a table.
NB.
NB. table may be numeric or boxed
NB.
NB. Examples:
NB.
NB.    border 10 * i.3 6
NB. +-+-----------------------+
NB. | |  0   1   2   3   4   5|
NB. +-+-----------------------+
NB. |0|  0  10  20  30  40  50|
NB. |1| 60  70  80  90 100 110|
NB. |2|120 130 140 150 160 170|
NB. +-+-----------------------+
NB.
NB.    ('abc';'abcdef') border 10 * i.3 6
NB. +-+-----------------------+
NB. | |  a   b   c   d   e   f|
NB. +-+-----------------------+
NB. |a|  0  10  20  30  40  50|
NB. |b| 60  70  80  90 100 110|
NB. |c|120 130 140 150 160 170|
NB. +-+-----------------------+
NB.
NB.    'ron tom mary' border 10 * i.3 6
NB. +----+-----------------------+
NB. |    |  0   1   2   3   4   5|
NB. +----+-----------------------+
NB. |ron |  0  10  20  30  40  50|
NB. |tom | 60  70  80  90 100 110|
NB. |mary|120 130 140 150 160 170|
NB. +----+-----------------------+
NB.
NB.    ('ron tom mary';1 + i.6) border 10 * i.3 6
NB. +----+-----------------------+
NB. |    |  1   2   3   4   5   6|
NB. +----+-----------------------+
NB. |ron |  0  10  20  30  40  50|
NB. |tom | 60  70  80  90 100 110|
NB. |mary|120 130 140 150 160 170|
NB. +----+-----------------------+
NB.
NB.    (100 200 300;'ron tom mary jane henry dave') border 10 * i.3 6
NB. +---+----------------------------+
NB. |   |ron tom mary jane henry dave|
NB. +---+----------------------------+
NB. |100|  0  10   20   30    40   50|
NB. |200| 60  70   80   90   100  110|
NB. |300|120 130  140  150   160  170|
NB. +---+----------------------------+

border=: 3 : 0
'' border y.
:
'r c'=. 2 {. boxopen x.
y=. (_2 {. 1 1 , $ y.) $ , y.
'rws cls'=. $ y
if. 0 = #r do.
  r=. i.rws
else.
  if. 2 = 3!:0 r do.
    if. ' ' e. r do.
      r=. cutopen r
    else.
      if. rws = 1 do.
        r=. ,<r
      else.
        r=. ;/r
      end.
    end.
  end.
end.
r=. ,@": &> r
if. 0=#c do.
  c=. ": each i.cls
else.
  if. 2 = 3!:0 c do.
    if. ' ' e. c do.
      c=. cutopen c
    else.
      if. cls = 1 do.
        c=. ,<c
      else.
        c=. ;/c
      end.
    end.
  else.
    c=. ": each c
  end.
  
end.
r=. '' ; rws $ r
c=. cls $ c
if. L. y do.
  y=. ": each y.
  len=. - 1 + >./ # &> c , y
  y=. <@:>"1 |: len {.each"1 y
else.
  y=. ' ',. ":y
  y=. ('';' ' *./ . = y) <;._1 y
  len=. - 1 + (# &> c) >. {:@$ &> y
  y=. len {."1 each y
end.

c=. }. ; len {.each c
y=. }."1 > ,.&.>/ y
r,. c ; y

)
